// Rodent's Revenge by PsiGoo (Michael Holt) started 5.28.01 @ 8:28 (GMT)
// This source may be used or modified in any way as long as the original program is included in the distribution
// If you modify and/or improve the game you must release the source as well, and please email me.
// Please give credit where credit is due.
// Thanks goes to Kurt Hoffmann, Zeljko Juric, Thomas Nussbaumer,
//   and Adam Sliger for the help with sprites and the great background.




#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files
#include "extgraph.h"					// Thomas Nussbaumer's ExtGraph routines
#include "sprites.h"					// Sprites
#include "levels.h"

short _ti89; 								// make 89y and 89z
#define _ti89 							// use 89 keyboard codes
//short _ti92plus; 					// make 9xy and 9xz
//#define _ti92p 						// use 92+ keyboard codes


int player_x=0, player_y=0,camera_x=-3,camera_y=-3;
char cats=0;
int life=0;
int catx[10],caty[10],catt[10];
int catssofar=0;
int timer=0;
unsigned int score=0;
char mousetrap=0;
char holemouse=0;
char deadmouse=0;
char levtype=0;
char speed=2,camspeed=4,manual_camera_speed=6;
char slevel=0;

#include "key.h"
#include "neo.h"
#include "ion.h"
#include "letters.h"
#include "game.h"
#include "bg.h"
char version[]="v0.8";

typedef struct {
  char name[10];
  unsigned int score;
} HSC_ITEM;




void titlescreen(int paused) {
  int x,y;
  int tilewidth  = 16;
  int tileheight = 16;
  int vcount     = 6;
  int hcount     = 10;
  int i;
	if(paused==1) for(i=0;i<=7;i++) {OSContrastDn();pause(50);}
  memset(GetPlane(0),0,LCD_SIZE);
  memset(GetPlane(1),0,LCD_SIZE);
  for (y=0;y<vcount;y++) {
    for (x=0;x<hcount;x++) { 
      int offset = (y*hcount+x)*tileheight;
        for (i=0;i<2;i++) {
          Sprite16(x*tilewidth,y*tileheight,tileheight,&bg[i][offset],GetPlane(i),SPRT_OR);
        }
      }
    }
	DisplaySpriteString(0,0,"by:psigoo",0,0);
	DisplaySpriteString(120,0,version,0,0);
  if(paused==1) for(i=0;i<=7;i++) {OSContrastUp();pause(50);}
}





////////////////////////////////////////////////////////////////////////////////////////////////
// Read or Write high score table
// Thanks goes to Kurt Hoffmann
////////////////////////////////////////////////////////////////////////////////////////////////
void hsc_RW(HSC_ITEM hsc_table[], char write)
{
	FILE *phile;
	if(write==1){
		EM_moveSymFromExtMem($(rrset), HS_NULL); 
		phile = fopen("rrset", "wb");
    fwrite(&speed,sizeof(char),1,phile);
    fwrite(&slevel,sizeof(char),1,phile);
    fwrite(&levtype,sizeof(char),1,phile);
    fwrite(hsc_table, 5*sizeof(HSC_ITEM),1,phile);
		fputc(0, phile);
		fputs("INI", phile);
		fputc(0, phile);
		fputc(OTH_TAG, phile);
		fclose(phile);}
	if(write==0) { //read
		phile = fopen("rrset", "rb");
		if(phile != NULL) {
	    fread(&speed,sizeof(char),1,phile);
  	  fread(&slevel,sizeof(char),1,phile);
    	fread(&levtype,sizeof(char),1,phile);
			fread(hsc_table,5*sizeof(HSC_ITEM),1,phile);}
		fclose(phile);}
}





////////////////////////////////////////////////////////////////////////////////////////////////
// Draw high score table
// Thanks goes to Zeljko Juric
////////////////////////////////////////////////////////////////////////////////////////////////
void high_scores(HSC_ITEM hsc_table[])
{
  int i;
	char buffer[20];
	SetPlane(0);clrscr();SetPlane(1);clrscr();
  titlescreen(0);
  DisplaySpriteString(38,20,"highscores",0,0);
  for(i=0;i<=4;i++){
		sprintf(buffer,"%d.",i+1);
		DisplaySpriteString(12,30+12*i,buffer,0,0);
		DisplaySpriteString(30,30+12*i,hsc_table[i].name,0,0);
		sprintf(buffer,"%d",hsc_table[i].score);
		DisplaySpriteString(120,30+12*i,buffer,0,0);}
  wait_for_enter_or_escape();hsc_RW(hsc_table,1);
	SetPlane(0);clrscr();SetPlane(1);clrscr();
	titlescreen(0);
}





////////////////////////////////////////////////////////////////////////////////////////////////
// Slighly modified Input String
// by: Zeljko Juric
////////////////////////////////////////////////////////////////////////////////////////////////
void input_str(char *str,int x,int y,int maxlen)
{
  int i=0,key=0;
  while(key!=13)
    {
      str[i]='_'; str[i+1]=' '; str[i+2]=0;
			FontSetSys(F_8x10);
      SetPlane(0);printf_xy(x,y,str);
      SetPlane(1);printf_xy(x,y,str);
      key=ngetchx();
      if(key>=' '&&key<='~'&&i<maxlen) str[i++]=key;
      if(key==257&&i) i--;
    }
  str[i]=0;
}





////////////////////////////////////////////////////////////////////////////////////////////////
// Update Highscore table
// by: Zeljko Juric
////////////////////////////////////////////////////////////////////////////////////////////////
void update_hsc(HSC_ITEM hsc_table[],unsigned long score)
{
  int i;
	SetPlane(0);ClrScr();SetPlane(1);ClrScr();
	Control_int_1(RESTORE);
	GrayOn();
	titlescreen(0);
  for(i=4;(hsc_table[i-1].score<score)&&i;i--)
    memcpy(&hsc_table[i],&hsc_table[i-1],sizeof(HSC_ITEM));
  hsc_table[i].score=score;
  text(30,"well done",0,0);
  input_str(hsc_table[i].name,50,81,8);hsc_RW(hsc_table,1);
	SetPlane(0);ClrScr();SetPlane(1);ClrScr();
	GrayOff();
	Control_int_1(SAVE);
  high_scores(hsc_table);
}





////////////////////////////////////////////////////////////////////////////////////////////////
// Draws the speed meter
// input: coordinates (x,y), fill=1,2,3,or 4
////////////////////////////////////////////////////////////////////////////////////////////////
void drawmeter(int x,int y,int fill)
{
	int i;
	SetPlane(LIGHT_PLANE);
	for(i=1;i<=15;i++) DrawLine(x+i,y,x+i,y+7,A_REVERSE);	
	DrawClipRect (MakeWinRect (x, y, x+16, y+7), &(SCR_RECT){{0, 0, 159, 99}}, A_NORMAL);
	for(i=1;i<=fill*3;i++) DrawLine(x+i,y,x+i,y+7,A_NORMAL);	
	DrawLine(x+fill*3+2,y,x+fill*3+2,y+7,A_NORMAL);
	SetPlane(DARK_PLANE);
	for(i=1;i<=15;i++) DrawLine(x+i,y,x+i,y+7,A_REVERSE);	
	DrawClipRect (MakeWinRect (x, y, x+16, y+7), &(SCR_RECT){{0, 0, 159, 99}}, A_NORMAL);
	for(i=1;i<=fill*3+1;i++) DrawLine(x+i,y,x+i,y+7,A_NORMAL);	
}


void Xpsk(void){
	while(_rowread(ARROWS_ROW)&UP_KEY){}
	while(_rowread(ARROWS_ROW)&DOWN_KEY){}
	while(_rowread(ARROWS_ROW)&LEFT_KEY){}
	while(_rowread(ARROWS_ROW)&RIGHT_KEY){}
	while(_rowread(ENTER_ROW)&ENTER_KEY){}
	while(_rowread(ARROWS_ROW)&SECOND_KEY){}}


void inverserectangle(int w){
	char i;
	SetPlane(DARK_PLANE);for(i=12*w+51;i<12*w+61;i++) DrawLine(21,i,138,i, A_XOR);
	SetPlane(LIGHT_PLANE);for(i=12*w+51;i<12*w+61;i++) DrawLine(21,i,138,i, A_XOR);
	
	
}



////////////////////////////////////////////////////////////////////////////////////////////////
// Main Menu
// starts game, options, highscore, and exit
////////////////////////////////////////////////////////////////////////////////////////////////
void mainmenu(HSC_ITEM hsc_table[]){
	char w=0,wb=1,exitb=0,key,exit=0,buffer[8],changedb=1,changeda=1;
	titlescreen(1);changeda=1;
	while(exit==0){
		//titlescreen(0);
		if(changeda==1) {
			text(12*0+52,"start",0,0);
			text(12*1+52,"options",0,0);
			text(12*2+52,"highscores",0,0);
			text(12*3+52,"exit",0,0);
			inverserectangle(w);changeda=0;Xpsk();}
		key=_rowread(ARROWS_ROW);
		if(key&UP_KEY){
			inverserectangle(w);
			//titlescreen(0);
			if(w==0) w=4;
			if(w>0) w--;changeda=1;}
		if(key&DOWN_KEY){
			inverserectangle(w);
		  //titlescreen(0);
			if(w==3) w=-1;
			if(w<3) w++;
			if(w==-1) w=0;changeda=1;}
		if(_rowread(ENTER_ROW)&ENTER_KEY||(_rowread(ARROWS_ROW)&SECOND_KEY)){
			if(w==0) {
				game(1);
				if(score>hsc_table[4].score) update_hsc(hsc_table,score);
				while(_rowread(ESC_ROW)&ESC_KEY);titlescreen(0);changeda=1;}
			if(w==1) {
				titlescreen(0);changedb=1;
				while(exitb==0) {
					if(changedb==1) {
						DisplaySpriteString(40, 12*1+52,"Speed:",0,0);
						drawmeter(109,12*1+52,speed);
						DisplaySpriteString(40, 12*2+52,"levels:",0,0);
					 	if(levtype==1) DisplaySpriteString(92, 12*2+52,"random",0,0);
					 	if(levtype==0) DisplaySpriteString(92, 12*2+52,"int",0,0);
						sprintf(buffer,"level:%d",slevel+1);
						DisplaySpriteString(40, 12*3+52,buffer,0,0);
						inverserectangle(wb);changedb=0;Xpsk();}
					if(_rowread(ESC_ROW)&ESC_KEY) exitb=1;
					key=_rowread(ARROWS_ROW);
					if(key&UP_KEY) {
					  //titlescreen(0);
						inverserectangle(wb);
						if(wb==1) wb=4;
						if(wb>1) wb--;changedb=1;}
					if(key&DOWN_KEY) {
					  //titlescreen(0);
						inverserectangle(wb);
						if(wb==3) wb=0;
						if(wb<3) wb++;changedb=1;}
					if(key&LEFT_KEY&&speed>0&&wb==1) {speed--;titlescreen(0);changedb=1;}
					if(key&RIGHT_KEY&&speed<4&&wb==1) {speed++;titlescreen(0);changedb=1;}
					if(key&LEFT_KEY&&slevel>0&&wb==3) {slevel--;titlescreen(0);changedb=1;}
					if(key&RIGHT_KEY&&slevel<howmanyinternallevels-1&&wb==3) {slevel++;titlescreen(0);changedb=1;}
					if(_rowread(ENTER_ROW)&ENTER_KEY||(_rowread(ARROWS_ROW)&SECOND_KEY)){
						if(wb==1) {if(speed<5) speed++; if(speed==5) speed=0;titlescreen(0);changedb=1;}
						if(wb==2) {if(levtype==0) levtype=2; levtype--;titlescreen(0);changedb=1;}
						if(wb==3) if(slevel<howmanyinternallevels) slevel++; if(slevel==howmanyinternallevels) slevel=0;titlescreen(0);changedb=1;}}
				while(_rowread(ESC_ROW)&ESC_KEY);
				exitb=0;
				titlescreen(0);changeda=1;}
  		if(w==2) {high_scores(hsc_table);while(_rowread(ESC_ROW)&ESC_KEY);titlescreen(0);changeda=1;}
			if(w==3) exit=1;}
		if(_rowread(ESC_ROW)&ESC_KEY) exit++;}
}













void _main(void)
{
	HSC_ITEM hsc_table[5]={{"--------", 500},{"--------", 250},{"--------", 100},{"--------", 50},{"--------", 25}};
	Control_int_1(SAVE);
	
	hsc_RW(hsc_table,0);
	mainmenu(hsc_table);
	hsc_RW(hsc_table,1);

	Control_int_1(RESTORE);
}
